<?php
 
namespace IPQualityScore\IPQualityScore\Controller\Adminhtml\Index;
 
use Magento\Backend\App\Action\Context;
use Magento\Framework\View\Result\PageFactory;
 
class Report extends \Magento\Backend\App\Action
{
    protected $resultPageFactory;
    private $scopeConfig;

    public function __construct(
        Context $context,
        PageFactory $resultPageFactory,
        \Magento\Framework\App\Config\ScopeConfigInterface $scopeConfig
    )
    {
        parent::__construct($context);
        $this->resultPageFactory = $resultPageFactory;
        $this->scopeConfig = $scopeConfig;
    }

    public function execute()
    {
        try{
            $isAuthed = $this->scopeConfig->getValue('ipqualityscore/general/auth_token',\Magento\Store\Model\ScopeInterface::SCOPE_STORE);
            $orderId = $_REQUEST['orderId'];
            $objectManager = \Magento\Framework\App\ObjectManager::getInstance();
            $resource = $objectManager->get('Magento\Framework\App\ResourceConnection');
            $connection = $resource->getConnection();
            $sql = "SELECT * FROM ipqualityscore_orders  WHERE order_id= ?";
            $query = $connection->prepare($sql);
            $query->bindParam(1,$orderId);
            $query->execute();
            $order = $query->fetchAll(\PDO::FETCH_CLASS);
            if($order){
                $sql = 'UPDATE ipqualityscore_orders SET reported=1 WHERE order_id=?';
                $data = $connection->prepare($sql);
                $data->bindParam(1, $orderId);
                $integration = new \IpQualityScore\Integration($isAuthed,'magentov2');
                $response = $integration->report($order[0]->request_id);
                echo $response;
            }
            die();
        }catch(\Exception $e){
            echo $e->getMessage();
        }
    }
}
