<?php

namespace Ipqualityscore\Ipqualityscore\Events\Observer;

use Magento\Framework\Event\ObserverInterface;
use Psr\Log\LoggerInterface;

class AdminLogin implements ObserverInterface
{
 protected $logger;
 protected $scopeConfig;

 public function __construct(LoggerInterface $logger,\Magento\Framework\App\RequestInterface $request, \Magento\Framework\View\Page\Config $pageConfig,  \Magento\Framework\App\Config\ScopeConfigInterface $scopeConfig ) {
     $this->logger = $logger;
     $this->_request = $request;
     $this->_page = $pageConfig;
     $this->scopeConfig = $scopeConfig;
 }

 public function execute(\Magento\Framework\Event\Observer $observer)
 {
    try {
        require_once dirname(__FILE__) . '/../../Integration.php';
        $isAuthed = $this->scopeConfig->getValue('ipqualityscore/general/auth_token',\Magento\Store\Model\ScopeInterface::SCOPE_STORE);
        if( $isAuthed ){
            $blockAll = $this->scopeConfig->getValue('ipqualityscore/general/block_all',\Magento\Store\Model\ScopeInterface::SCOPE_STORE);
            $blockVpn = $this->scopeConfig->getValue('ipqualityscore/general/block_vpn',\Magento\Store\Model\ScopeInterface::SCOPE_STORE);
            $blockTor = $this->scopeConfig->getValue('ipqualityscore/general/block_tor',\Magento\Store\Model\ScopeInterface::SCOPE_STORE);
            $strictness = $this->scopeConfig->getValue('ipqualityscore/general/strictness',\Magento\Store\Model\ScopeInterface::SCOPE_STORE);
            $allowPublic = $this->scopeConfig->getValue('ipqualityscore/general/allow_public',\Magento\Store\Model\ScopeInterface::SCOPE_STORE)?true:false;
            $allowCrawlers = $this->scopeConfig->getValue('ipqualityscore/general/allow_crawlers',\Magento\Store\Model\ScopeInterface::SCOPE_STORE)?true:false;
            $blockScore = $this->scopeConfig->getValue('ipqualityscore/general/block_score',\Magento\Store\Model\ScopeInterface::SCOPE_STORE);
            $redirect = $this->scopeConfig->getValue('ipqualityscore/general/redirect',\Magento\Store\Model\ScopeInterface::SCOPE_STORE);
	    $allowAdminProxyLogin =  $this->scopeConfig->getValue('ipqualityscore/general/allow_admin_login',\Magento\Store\Model\ScopeInterface::SCOPE_STORE);
            $client = new \IpqualityScore\Integration($isAuthed, 'magentov2');
            if (!$allowAdminProxyLogin) {
                $client = new \IpqualityScore\Integration($isAuthed, 'magentov2');
                $response = $client->validateProxy($strictness, $allowPublic);
                if ($response->proxy || $response->vpn || $response->tor ) {
                    if ($allowCrawlers && $response->is_crawler) {
                    } else {
                        if ($redirect) {
                            header("Location: {$redirect}");
                        }
                    }
                    die();
                }
            }

        }
    }catch (\Exception $e) {
        $this->logger->info($e->getMessage());
    }
 }
}
